C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE FMOSRT                                               *
C *                                                                  *
C *  Routine of ICONC                                                *
C *                                                                  *
C *  Usage......: does FMO calculation.                              *
C *                                                                  *
C *  Author ....: Charles Wilker (R. Hoffmann group)                 *
C *  Date.......: December 1981                                      *
C *  Revision...: last revision 24.08.97/mbs (Martin Braendle)       *
C *  Available..: Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *  Remarks....: Adapted from the BIGICON version.                  *
C *                                                                  *
C *  Called from: HUCKEL                                             *
C *                                                                  *
C *  Calls......: MATOUT                                             *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE FMOSRT(H,S,C,U,H1,H2,H3,H4,H5,H6,H7,H8,H9, NDIM,NC,
     .                  NATOM, ND1,ND2,ND3,ND4,ND5,ND6,ND7,ND8,ND9)
 
      INCLUDE 'iconpara.for'
 
      IMPLICIT REAL*8(A-H,O-Z)
 
      INTEGER ND1,ND2,ND3,ND4,ND5,ND6,ND7,ND8,ND9
      DIMENSION H(NDIM,NDIM),S(NDIM,NDIM),C(NC),U(NDIM,NDIM)
      DIMENSION H1(ND1,ND1),H2(ND2,ND2),H3(ND3,ND3),H4(ND4,ND4),
     .          H5(ND5,ND5),H6(ND6,ND6),H7(ND7,ND7),H8(ND8,ND8),
     .          H9(ND9,ND9)
 
      COMMON /ATOM/EXPS(MXATOM),EXPP(MXATOM),EXPD(MXATOM),EXPD2(MXATOM),
     .             C1(MXATOM),C2(MXATOM),COULS(MXATOM),COULP(MXATOM),
     .             COULD(MXATOM),X(MXATOM),Y(MXATOM),Z(MXATOM),
     .             KEY(MXATOM),AC(MXATOM),VELEC(MXATOM),NS(MXATOM),
     .             NP(MXATOM),ND(MXATOM)
      INTEGER AC,VELEC,KEY
 
      COMMON/FMO/FMO(MXATOM),FMOCH(9),SORA(MXATOM),SORB(MXATOM),
     .           NFRAG(9),NUMBAT(9),IFMOPT(4*MXATOM),IBCKPT(MXATOM),
     .           PRIFMO(7)
      INTEGER FMO,FMOCH,SORA,SORB
      LOGICAL*1 PRIFMO
 
      COMMON/OUT/PRT(24),PUN(24),IOVPOP(24),IENRGY(24)
      LOGICAL*1 PRT,PUN
      INTEGER IOVPOP,IENRGY
 
      COMMON/CNTRL/CON,PEEP,COULH,NH,NA,NATM,KA,NELEC,METH,
     . IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
      LOGICAL*1 L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
 
      INTEGER*4 NPT(4*MXATOM)
 
      PRT(4)=PRIFMO(1)
      PRT(10)=PRIFMO(2)
      PRT(12)=PRIFMO(3)
      PRT(13)=PRIFMO(4)
      PRT(14)=PRIFMO(5)
      PRT(15)=PRIFMO(6)
      PRT(16)=PRIFMO(7)
C
C  READ IN OVERLAP MATRIX FROM SCRATCH FILE
C
      REWIND 9
      READ(9) ((S(I,J),I=1,NDIM),J=1,NDIM)
C
C  REORGANIZE OVERLAP AND WAVEFUNCTIONS INTO FRAGMENT ORDER
C
      DO 10 I=1,NDIM
10      NPT(I)=I
      IC=1
      ICNT=1
      DO 11 IJ=1,9
        DO 12 IK=1,NATOM
          IF (FMO(IK).NE.IJ) GOTO 12
          IS=SORA(IK)
          IE=SORA(IK+1)-1
          DO 14 I=IS,IE
            IW=NPT(I)
            IW1=IW-1
            IF (IW.EQ.IC) GOTO 14
            DO 15 J=1,NDIM
              T1=H(IW,J)
              T2=S(IW,J)
              KK=IW
              DO 16 K=IC,IW1
                S(KK,J)=S(KK-1,J)
                H(KK,J)=H(KK-1,J)
16              KK=KK-1
              S(IC,J)=T2
15            H(IC,J)=T1
            DO 19 J=1,NDIM
              T2=S(J,IW)
              KK=IW
              DO 18 K=IC,IW1
                S(J,KK)=S(J,KK-1)
18              KK=KK-1
19            S(J,IC)=T2
            DO 17 K=1,NDIM
              IF (NPT(K).GE.IC.AND.NPT(K).LT.IW) NPT(K)=NPT(K)+1
17          CONTINUE
            NPT(I)=IC
14          IC=IC+1
          KEY(ICNT)=AC(IK)
          ICNT=ICNT+1
          SORB(ICNT)=IC
12      CONTINUE
11    CONTINUE
C
C  der mit /mbs/ eingeklammerte Teil wird spaeter wieder als Comment
C  kaschiert. 05.11.90/mbs/
C       WRITE(6,1914)
C 1914  FORMAT(//,' FMO REORGANIZED OVERLAP MATRIX',//)
C       CALL MATOUT(S,NDIM,NDIM)
C       WRITE(6,1915)
C 1915  FORMAT(//,' FMO REORGANIZED WAVEFUNCTION MATRIX',//)
C       CALL MATOUT(H,NDIM,NDIM)
C  /mbs/
C
C  FMO
C
      WRITE(6,101)
101   FORMAT('1',//,1X,50('*'),'   FMO   ',50('*'),/)
 
      REWIND 9
      WRITE(9) ((H(I,J),I=1,NDIM),J=1,NDIM)
C
C  GET FRAGMENT WAVEFUNCTION MATRICES AND BUILD THE BLOCK WAVEFUNCTION
C  MATRIX
C
      DO 40 I=1,NDIM
        DO 40 J=1,NDIM
40        H(I,J)=0.D0
 
      IS=0
      IF (NFRAG(1).LE.0) GOTO 220
      DO 41 I=1,ND1
        II=I+IS
        DO 41 J=1,ND1
          JJ=J+IS
41        H(II,JJ)=H1(I,J)
      IS=IS+ND1
 
      IF (NFRAG(2).LE.0) GOTO 220
      DO 42 I=1,ND2
        II=I+IS
        DO 42 J=1,ND2
          JJ=J+IS
42        H(II,JJ)=H2(I,J)
      IS=IS+ND2
 
      IF (NFRAG(3).LE.0) GOTO 220
      DO 43 I=1,ND3
        II=I+IS
        DO 43 J=1,ND3
          JJ=J+IS
43        H(II,JJ)=H3(I,J)
      IS=IS+ND3
 
      IF (NFRAG(4).LE.0) GOTO 220
      DO 44 I=1,ND4
        II=I+IS
        DO 44 J=1,ND4
          JJ=J+IS
44        H(II,JJ)=H4(I,J)
      IS=IS+ND4
 
      IF (NFRAG(5).LE.0) GOTO 220
      DO 45 I=1,ND5
        II=I+IS
        DO 45 J=1,ND5
          JJ=J+IS
45        H(II,JJ)=H5(I,J)
      IS=IS+ND5
 
      IF (NFRAG(6).LE.0) GOTO 220
      DO 46 I=1,ND6
        II=I+IS
        DO 46 J=1,ND6
          JJ=J+IS
46        H(II,JJ)=H6(I,J)
      IS=IS+ND6
 
      IF (NFRAG(7).LE.0) GOTO 220
      DO 47 I=1,ND7
        II=I+IS
        DO 47 J=1,ND7
          JJ=J+IS
47        H(II,JJ)=H7(I,J)
      IS=IS+ND7
 
      IF (NFRAG(8).LE.0) GOTO 220
      DO 48 I=1,ND8
        II=I+IS
        DO 48 J=1,ND8
          JJ=J+IS
48        H(II,JJ)=H8(I,J)
      IS=IS+ND8
 
      IF (NFRAG(9).LE.0) GOTO 220
      DO 49 I=1,ND9
        II=I+IS
        DO 49 J=1,ND9
          JJ=J+IS
49        H(II,JJ)=H9(I,J)
      IS=IS+ND9
 
220   CONTINUE
C
C  der mit /mbs/ eingeklammerte Teil wird spaeter wieder als Comment
C  kaschiert. 05.11.90/mbs/
C       WRITE(6,1916)
C 1916  FORMAT(//,' FMO BLOCK WAVEFUNCTIONS',//)
C       CALL MATOUT(H,NDIM,NDIM)
C  /mbs/
C
C  LOAD SORB WITH FRAGMENT SIZES
C
      IS=1
      DO 80 I=1,9
        IF (NFRAG(I).GT.0) NATOM=I
        IS=IS+NFRAG(I)
80      SORB(I+1)=IS
C
C  MULTIPLY TRANSPOSE OF BLOCK BY MOLECULAR WAVEFUNCTIONS
C
      DO 50 I1=1,NDIM
        DO 51 I2=1,NDIM
          SUM=0.D0
          DO 52 I3=1,NDIM
52          SUM=SUM+H(I3,I1)*S(I3,I2)
51        U(I1,I2)=SUM
50    CONTINUE
C
C  der mit /mbs/ eingeklammerte Teil wird spaeter wieder als Comment
C  kaschiert. 05.11.90/mbs/
C       WRITE(6,1913)
C 1913  FORMAT(//,' FMO TWO MATRICES',//)
C       CALL MATOUT(U,NDIM,NDIM)
C  /mbs/
C
C  MULTIPLY TO FORM FMO OVERLAP MATRIX
C
      DO 62 I1=1,NDIM
        DO 63 I2=1,NDIM
          SUM=0.D0
          DO 64 I3=1,NDIM
64          SUM=SUM+U(I1,I3)*H(I3,I2)
63        S(I1,I2)=SUM
62    CONTINUE
 
      IF (PRT(4)) GOTO 210
      WRITE(6,1787)
1787  FORMAT('0OVERLAP MATRIX (FOR FRAGMENT MOLECULAR ORBITALS)')
      CALL MATOUT(S,NDIM,NDIM)
C
C  LOAD FMO OVERLAP MATRIX INTO C
C
210   K=1
      DO 30 I=2,NDIM
        IL=I-1
        DO 30 J=1,IL
          C(K)=S(I,J)
30        K=K+1
 
      REWIND 9
      READ(9)((S(I,J),I=1,NDIM),J=1,NDIM)
      CLOSE(UNIT=9)
C
C  der mit /mbs/ eingeklammerte Teil wird spaeter wieder als Comment
C  kaschiert. 05.11.90/mbs/
C       WRITE(6,1917)
C 1917  FORMAT(//,' FMO WAVEFUNCTIONS READ BACK IN',//)
C       CALL MATOUT(S,NDIM,NDIM)
C  /mbs/
C
C  MULTIPLY TO FORM FMO MATRIX
C
      IS=1
      DO 73 I=1,9
        IF (NFRAG(I).LE.0) GOTO 73
        IE=IS+NFRAG(I)-1
        DO 70 I1=IS,IE
          DO 71 I2=1,NDIM
            SUM=0.D0
            DO 72 I3=IS,IE
72            SUM=SUM+U(I1,I3)*S(I3,I2)
71          H(I1,I2)=SUM
70      CONTINUE
        IS=IE+1
73    CONTINUE
 
      IF (PRT(10)) GOTO 999
      WRITE(6,1484)
1484  FORMAT('0WAVEFUNCTIONS',//,
     . ' MOLECULE MOLECULAR ORBITALS IN COLUMNS, FRAGMENT MOLECULAR',
     . ' ORBITALS IN ROWS')
      CALL MATOUT(H,NDIM,NDIM)
 
999   RETURN
      END
