C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE FULCHM                                               *
C *                                                                  *
C *  Routine of ICONC(S)                                             *
C *                                                                  *
C *  Usage......: Calculates complete charge matrix.                 *
C *                                                                  *
C *  Authors....: -                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: OUTPUT                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE FULCHM(E,U,C,H,N5)
      REAL*8 E(N5),C(N5),U(N5,N5),H(N5,N5),UB
      LOGICAL*1 JGO

      KJ=1
      DO 31 I=1,N5
        JGO=.FALSE.
        IJ=KJ
        DO 32 K=1,N5
          IF (JGO) GOTO 34
          IF (I.NE.K) GOTO 35
          JGO=.TRUE.
          E(K)=1.0D0
          GOTO 32
35        E(K)=C(IJ)
          IJ=IJ+1
          GOTO 32
34        IJ=IJ+K-2
          E(K)=C(IJ)
32      CONTINUE
        KJ=KJ+I-1
        DO 31 J=1,N5
          UB=0.0D0
          DO 36 K=1,N5
36          UB=UB+H(K,J)*E(K)
31        U(I,J)=2.0D0*H(I,J)*UB
      RETURN
      END
