C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE GRMSCH                                               *
C *                                                                  *
C *  Routine of ICONC(S)                                             *
C *                                                                  *
C *  Usage......: Does Gram-Schmidt-diagonalization.                 *
C *                                                                  *
C *  Authors....: -                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: HUCKEL                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE GRMSCH(U,C,NDIM,NC)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION U(NDIM,NDIM),C(NC)

      U(1,1)=1.D0
      DO 100 I=2,NDIM
        I1=I-1
        XNORM=1.D0
        DO 40 J=1,I1
          SUM=0.D0
          DO 30 K=1,J
            SUM=SUM+U(K,J)*U(K,I)
 30       CONTINUE
          C(J)=SUM
          XNORM=XNORM-SUM**2
 40     CONTINUE
        XNORM=DSQRT(1.D0/XNORM)
        DO 70 J=1,I1
          SUM=0.D0
          DO 60 K=J,I1
            SUM=SUM+C(K)*U(J,K)
 60       CONTINUE
          U(J,I)=-SUM*XNORM
 70     CONTINUE
        U(I,I)=XNORM
 100  CONTINUE
      RETURN
      END
