C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE INPRT                                                *
C *                                                                  *
C *  Routine of ICONC                                                *
C *                                                                  *
C *  Usage......: Prints input information.                          *
C *                                                                  *
C *  Authors....: -                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 24.10.90/mbs (Martin Braendle)                     *
C *  Revision...: last revision 04.05.93/mbs                         *
C *  Remarks....: adapted from the SUBROUTINES INPUT from the ICON-  *
C *               versions BIGICON (Hoffmann group) and ICONCL (Cal- *
C *               zaferri group).                                    *
C *               Output of k-parameter and omit-atom-specifications *
C *               added. 24.06.91/mbs                                *
C *                                                                  *
C *  Called from: INPUT                                              *
C *               FMOR                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE INPRT(NATOM,NCH,NUMB)

      INCLUDE 'iconpara.for'

      IMPLICIT REAL*8(A-H,O-Z)

      COMMON /ATOM/EXPS(MXATOM),EXPP(MXATOM),EXPD(MXATOM),EXPD2(MXATOM),
     .             C1(MXATOM),C2(MXATOM),COULS(MXATOM),COULP(MXATOM),
     .             COULD(MXATOM),X(MXATOM),Y(MXATOM),Z(MXATOM),
     .             KEY(MXATOM),AC(MXATOM),VELEC(MXATOM),NS(MXATOM),
     .             NP(MXATOM),ND(MXATOM)
      INTEGER AC,VELEC,KEY

      COMMON /CNTRL/CON,PEEP,COULH,NH,NA,NATM,KA,NELEC,METH,IPRINT,
     .              IPUNCH,L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
      LOGICAL*1 L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT

      COMMON /OUT/PRT(24),PUN(24),IOVPOP(24),IENRGY(24)
      LOGICAL*1 PRT,PUN
      INTEGER   IOVPOP,IENRGY

      COMMON /ANEWDI/CWK,CWKALP,R(MXATOM,MXATOM)

      COMMON /FMO/FMO(MXATOM),FMOCH(9),SORA(MXATOM),SORB(MXATOM),
     .            NFRAG(9),NUMBAT(9),PRIFMO(7)
      INTEGER   FMO,FMOCH,SORA,SORB,NFRAG,NUMBAT
      LOGICAL*1 PRIFMO

      COMMON /KSET/KATOM(MXSETK,2),SETK(MXSETK),SETD(MXSETK),NKSET
      INTEGER NKSET,KATOM

      COMMON /OMITRP/NOMIT,OMIT(MXOMIT)
      INTEGER NOMIT,OMIT

      COMMON /STARS/STAR,STAR2,SYMBOL(MXATOM)
      CHARACTER*2 STAR,STAR2,SYMBOL
C
C  Print out type of calculation.
C
      IF (METH .EQ. 0) WRITE (6,10)
   10 FORMAT(///,T10,'EXTENDED HUCKEL CALCULATION.')
      IF (METH .EQ. 1) WRITE(6,20)
   20 FORMAT(///,T10,'EXTENDED HUCKEL CALCULATION WITH CHARGE ',
     .       'ITERATION.',/,T10,
     .       'LINEAR CHARGE DEPENDENCE OF SENSE*CHARGE FOR H(I,I)''S.')
      IF (METH .GE. 2) WRITE(6,30)
   30 FORMAT(///,T10,'EXTENDED HUCKEL CALCULATION WITH CHARGE',' 
     .ITERATION.')
      IF (METH .GT. 2) WRITE(6,40)
   40 FORMAT(T10,'MADELUNG CORRECTION INCLUDED.')
      IF (IPUNCH .EQ. 1) L5=.FALSE.
      IF (L5) WRITE(6,50)
   50 FORMAT(T10,'WEIGHTED HIJ FORMULA USED.')
      IF (IPUNCH .EQ. 1) WRITE(6,60) CWKALP,1.0D0+CWK
   60 FORMAT(//,T10,'K IS CALCULATED WITH THE DISTANCE-DEPENDENT ',
     .       'WEIGHTED FORMULA.',/,T10,'delta =',F10.4,',   1+kappa =',
     .       F10.4,/)
      IF (L6) WRITE(6,70)
   70 FORMAT(T10,'FMO CALCULATION.')
      IF (L7) THEN
        WRITE(6,80)
   80   FORMAT(T10,'INDIVIDUAL K SPECIFICATIONS FOR SEVERAL ATOM ',
     .         'PAIRS.',/)
        IF (NUMB .EQ. 0) THEN
          DO 100 I=1,NKSET
            WRITE(6,90) KATOM(I,1),SYMBOL(KEY(KATOM(I,1))),KATOM(I,2),
     .                  SYMBOL(KEY(KATOM(I,2))),SETK(I),SETD(I)
   90       FORMAT(T12,'(1+KAPPA,DELTA) BETWEEN ATOM # ',I3,'  (',A2,
     .             ') AND ATOM # ',I3,' (',A2,'): (',F10.5,',',F10.5,
     .             ')')
  100     CONTINUE
        ENDIF
      ENDIF
      IF (L8) THEN
        WRITE(6,110)
  110   FORMAT(T10,'SEVERAL ATOMS OMITTED FROM REPULSION ENERGY ',
     .             'CALCULATION.')
        IF (NUMB .EQ. 0) THEN
          DO 130 I=1,NOMIT
            WRITE(6,120) OMIT(I),SYMBOL(KEY(OMIT(I)))
  120       FORMAT(T12,' Omitted atom # ',I3,' (',A2,')')
  130     CONTINUE
        ENDIF
      ENDIF
C
C Print out atomic coordinates and parameters.
C
      WRITE(6,140)
  140 FORMAT(///,T5,'ATOM',T17,'X',T29,'Y',T41,'Z',T56,'S',T76,'P',T96,
     .       'D',T113,'CONTRACTED D'/T47,'N',T50,'EXP',T59,'COUL',T67,
     .       'N',T70,'EXP',T79,'COUL',T87,'N',T90,'EXPD1',T99,'COUL',
     .       T109,'C1',T118,'C2',T125,'EXPD2',/)
C
C can be excluded, since NH always = 0 /mbs
C       IF (NH.EQ.0) GOTO 72
C       J=1
C       DO 76 I=1,NH
C         WRITE(6,53) HYDROG,I,X(I),Y(I),Z(I),J,PEEP,COULH
C 76    CONTINUE
C
  150 FORMAT(' ',T4,A2,I3,3F12.5,3(I3,F8.4,F9.4),2F9.5,F8.4)
      IC=0
      DO 210 I=1,NATOM
        KEYI=KEY(I)
  160   IC=IC+1
        IF (NUMB .LE. 0) GOTO 170
        IF (FMO(IC) .NE. NUMB) GOTO 160
  170   XX=X(IC)
        YY=Y(IC)
        ZZ=Z(IC)
        IF (NP(KEYI) .NE. 0) GOTO 180
        WRITE(6,150) SYMBOL(KEYI),I,XX,YY,ZZ,NS(KEYI),EXPS(KEYI),
     .               COULS(KEYI)
        GOTO 210
  180   IF (ND(KEYI) .NE. 0) GOTO 190
        WRITE(6,150) SYMBOL(KEYI),I,XX,YY,ZZ,NS(KEYI),EXPS(KEYI),
     .               COULS(KEYI),NP(KEYI),EXPP(KEYI),COULP(KEYI)
        GOTO 210
  190   IF (C2(KEYI) .NE. 0.0D0) GOTO 200
        WRITE(6,150) SYMBOL(KEYI),I,XX,YY,ZZ,NS(KEYI),EXPS(KEYI),
     .               COULS(KEYI),NP(KEYI),EXPP(KEYI),COULP(KEYI),
     .               ND(KEYI),EXPD(KEYI),COULD(KEYI)
        GOTO 210
  200   WRITE(6,150) SYMBOL(KEYI),I,XX,YY,ZZ,NS(KEYI),EXPS(KEYI),
     .               COULS(KEYI),NP(KEYI),EXPP(KEYI),COULP(KEYI),
     .               ND(KEYI),EXPD(KEYI),COULD(KEYI),C1(KEYI),C2(KEYI),
     .               EXPD2(KEYI)
  210 CONTINUE
      IF ((IPUNCH .EQ. 1) .AND. ( .NOT. L5)) THEN
        WRITE(6,220) NCH,IPRINT,IPUNCH
  220   FORMAT(///,T10,'CHARGE =',I3,8X,'IPRINT =',I3,8X,'IPUNCH =',I3)
      ELSE
        WRITE(6,230) NCH,IPRINT,IPUNCH,CON
  230   FORMAT(///,T10,'CHARGE =',I3,8X,'IPRINT =',I3,8X,'IPUNCH =',I3,
     .        8X,'HUCKEL CONSTANT =',F7.3)
      ENDIF
      RETURN
      END
