C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE PEGLEG                                               *
C *  SUBROUTINE OUTMAT                                               *
C *                                                                  *
C *  Routine of ICONC(S)                                             *
C *                                                                  *
C *  Usage......: Print out matrices in readable format.             *
C *                                                                  *
C *  Authors....: -                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: 14.11.90/mbs (Martin Braendle)                     *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from:                                                    *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE PEGLEG(A,N,NL)

      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(NL,NL)

      NROW=N
      NCOL=N
      GOTO 10

      ENTRY OUTMAT(A,NL,NR,NC)
      NROW=NR
      NCOL=NC
10    KITE=0
20    LOW=KITE+1
      KITE=KITE+14
      IF (KITE.GT.NCOL) KITE=NCOL
      WRITE(6,1000) (I,I=LOW,KITE)
1000  FORMAT(/,5X,14I8,/)
      WRITE(6,1003)
1003  FORMAT( )
      DO 30 I=1,NROW
30      WRITE(6,1001) I,(A(I,J),J=LOW,KITE)
1001    FORMAT(I5,2X,14F8.4)
      IF (KITE.LT.NCOL) GOTO 20
      WRITE(6,1002)
1002  FORMAT(/)
      RETURN
      END
