C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SURBROUTINE TRNFRM                                              *
C *                                                                  *
C *  Routine of ICONC(S)                                             *
C *                                                                  *
C *  Usage......: Transforms huckel matrix in a form that can be     *
C *               used by the diagonalizer.                          *
C *                                                                  *
C *  Authors....: -                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: 17.01.91/mbs (Martin Braendle)                     *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: HUCK                                               *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE TRNFRM(H,S,C,COUL0,SP,NDIM,NC,IEXIT)

      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION H(NDIM,NDIM),S(NDIM,NDIM),C(NC),COUL0(NDIM),SP(NDIM)

      LOGICAL*1 ONEMAT

      ONEMAT=IEXIT.EQ.2.OR.IEXIT.EQ.3
      ISUB=1

      DO 100 J=1,NDIM
        DO 40 I=1,J
          SUM=0.D0
          ILIM=I
          IF (.NOT.ONEMAT) GOTO 10
          IF (I.LT.J) GOTO 10
          ILIM=I-1
C
C  IN THE ONE MATRIX CASE, THE S AND H MATRICES OVERLAP ALONG THE
C  DIAGONAL. THE DIAGONAL OF S IS THEN PUT INTO SP.
C
          SUM=SP(I)*H(I,I)
          IF (I.EQ.1) GOTO 25
10        DO 20 K=1,ILIM
20          SUM=SUM+S(K,J)*H(I,K)
25        IF(I.EQ.J) GO TO 40
          I1=I+1
          ILIM=J
          IF (.NOT.ONEMAT) GOTO 27
          ILIM=J-1
          SUM=SUM+SP(J)*H(J,I)
          IF (ILIM.LT.I1) GOTO 40
27        DO 30 K=I1,ILIM
30          SUM=SUM+S(K,J)*H(K,I)
40        COUL0(I)=SUM
        DO 60 I=1,J
          SUM=0.D0
          ILIM=I
          IF (.NOT.ONEMAT) GOTO 45
          ILIM=I-1
          SUM=COUL0(I)*SP(I)
          IF (ILIM.EQ.0) GOTO 55
45        DO 50 K=1,ILIM
50          SUM=SUM+COUL0(K)*S(K,I)
55        C(ISUB)=SUM
60        ISUB=ISUB+1
100   CONTINUE
      RETURN
      END
