C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE CHRIT                                                *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads charge iteration parameters from the files   *
C *               VOI  or FOI                                        *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM extended./mbs                   *
C *                                                                  *
C *  Called from: OUTPUT                                             *
C *                                                                  *
C *  Calls......: ERR                                                *
C *               FOI                                                *
C *               VOI                                                *
C *                                                                  *
C ********************************************************************

      SUBROUTINE CHRIT(NCON,PARTIT,JN)
      IMPLICIT REAL(A-H,O-Z)

      INCLUDE 'inpupara.for'

      LOGICAL PARTIT,L0

      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM

      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      OPEN (UNIT=2,FILE='VOI.DAT',STATUS='OLD')
      OPEN (UNIT=3,FILE='FOI.DAT',STATUS='OLD')
      IF (PARTIT) THEN
        WRITE(1,10) (ITAT(I),I=1,JN)
   10   FORMAT(40A2)
        DO 20 I=1,JN
          IF (NCON .EQ. 1) CALL VOI(ITAT(I),L0)
          IF (NCON .EQ. 3) THEN
            CALL FOI(ITAT(I),L0)
            IF (L0) CALL VOI(ITAT(I),L0)
          ENDIF
          IF (L0) CALL ERR(ITAT(I))
   20   CONTINUE
      ELSE
        DO 30 I=1,NA
          IF (NCON .EQ. 1) CALL VOI(SYMBOL(I),L0)
          IF (NCON .EQ. 3) THEN
            CALL FOI(SYMBOL(I),L0)
            IF (L0) CALL VOI(SYMBOL(I),L0)
          ENDIF
          IF (L0) CALL ERR(SYMBOL(I))
   30   CONTINUE
      ENDIF
      CLOSE (UNIT=2)
      CLOSE (UNIT=3)
      RETURN
      END
