C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE HEVIN                                                *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads user defined atom parameters.                *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....:                                                    *
C *                                                                  *
C *  Called from: HEAVY                                              *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE HEVIN (J)
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      CHARACTER*2 A,AI(3)
 
      COMMON/ATDEF/IVELEC(MXSYMB),NS(MXSYMB),EXPS(MXSYMB),COULS(MXSYMB),
     .             NP(MXSYMB),EXPP(MXSYMB),COULP(MXSYMB),ND(MXSYMB),
     .             EXPD(MXSYMB),COULD(MXSYMB),C1(MXSYMB),EXPD2(MXSYMB),
     .             C2(MXSYMB)
 
      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM
 
      EQUIVALENCE (A,AI)
 
   10 WRITE(6,20) J
   20 FORMAT($,' Atom #',I3,' symbol : ',$)
      READ(5,40,ERR=10) SYMBOL(J)
      IF (SYMBOL(J)(2:2) .EQ. ' ') THEN
        SYMBOL(J)(2:2) = SYMBOL(J)(1:1)
        SYMBOL(J)(1:1) = ' '
      ENDIF
C
C make uppercase
C
      DO 30 II=1,2
        IF (ICHAR(SYMBOL(J)(II:II)) .GE. 97) THEN
          SYMBOL(J)(II:II) = CHAR(ICHAR(SYMBOL(J)(II:II))-32)
        END IF
   30 CONTINUE
   40 FORMAT(A3)
   50 WRITE(6,60)
   60 FORMAT($,' Valence electrons: ')
      READ(5,*,ERR=50) IVELEC(J)
   70 WRITE(6,80)
   80 FORMAT($,' Ns ..............: ')
      READ(5,*,ERR=70) NS(J)
   90 WRITE(6,100)
  100 FORMAT($,' Exponent ........: ')
      READ(5,*,ERR=90) EXPS(J)
  110 WRITE(6,120)
  120 FORMAT($,' Coulombintegral .: ')
      READ(5,*,ERR=110) COULS(J)
  130 WRITE(6,140)
  140 FORMAT($,' Np ..............: ')
      READ(5,*,ERR=130) NP(J)
      IF (NP(J) .NE. 0) GO TO 150
      ICH=1
      GOTO 280
  150 WRITE(6,100)
      READ(5,*,ERR=150) EXPP(J)
  160 WRITE(6,120)
      READ(5,*,ERR=160) COULP(J)
  170 WRITE(6,180)
  180 FORMAT($,' Nd ..............: ')
      READ(5,*,ERR=170) ND(J)
      IF (ND(J) .NE. 0) GO TO 190
      ICH=2
      GOTO 280
  190 WRITE(6,200)
  200 FORMAT($,' Exponent d1 .....: ')
      READ(5,*,ERR=190) EXPD(J)
  210 WRITE(6,120)
      READ(5,*,ERR=210) COULD(J)
  220 WRITE(6,230)
  230 FORMAT($,' C1 ..............: ')
      READ(5,*,ERR=220) C1(J)
  240 WRITE(6,250)
  250 FORMAT($,' Exponent d2 .....: ')
      READ(5,*,ERR=240) EXPD2(J)
  260 WRITE(6,270)
  270 FORMAT($,' C2 ..............: ')
      READ(5,*,ERR=260) C2(J)
      ICH=3
  280 CONTINUE
      RETURN
      END
