C ********************************************************************
C *                                                                  *
C *  INPUPARA                                                        *
C *                                                                  *
C *  Includefile for INPUTC (QCMP #116)                              *
C *                                                                  *
C *  Usage......: Define dimension of INPUTC.                        *
C *                                                                  *
C *  Author.....: Martin Braendle (mbs)                              *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute for anorg. + phys. Chemistry             *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 23.11.92/mbs                                       *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C ********************************************************************
C 
C MXATOM: maximum number of atoms and atomic parameters
C MXDUMM: maximum number of dummy atoms
C MXATMD: maximum number of internal atomic parameters (read from
C         ATOMDEF.DAT
C MXITER: maximum number of atoms to be charge iterated
C MXSETK: maximum number of individual (kappa,delta) sets
C MXOMIT: maximum number of atoms to be omitted from repulsion energy
C         calculation
C MXAOOC: Maximum number of individual electron configurations
C MXVAR : Maximum number of variation lines
C MXODD : Maximum number of orbitals to be occupied with noninteger
C         electron numbers
C

      PARAMETER (MXATOM=400,MXDUMM=10,MXATMD=150,MXITER=20,
     .           MXSETK=10,MXOMIT=10,MXAOOC=10,MXVAR=80,MXODD=6)

      PARAMETER (MXSYMB=MXATOM+MXATMD,MXTOT=MXATOM+MXDUMM,
     .           MXORB=4*MXATOM)

