C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE INTKOR                                               *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads internal coordinates.                        *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89, by Thomas Hugentobler                    *
C *  Revision...: 17.10.91/mbs (Martin Braendle)                     *
C *  Remarks....: COMMON block PARAM extended./mbs                   *
C *  Revision...: 02.04.98/stg (Stephan Glaus)                                     *
C *  Remarks....: calculate number of vectors automatically/stg      *
C *                                                                  *
C *  Called from: CASE1                                              *
C *                                                                  *
C *  Calls......:                                                    *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE INTKOR
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM
 
      COMMON /CONVERT/IVERK,IPARA,IADEF,IADD,IDUMMY,ISUM,IDIST,IVA
 
      COMMON/INTERN/NATOM1(MXTOT),NATOM2(MXTOT),DIST(MXTOT),
     .              ANGLE(MXTOT),DIEDER(MXTOT)
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
   30 WRITE(6,40) MXDUMM-1
   40 FORMAT(/,' Number of dummy-atoms, max. ',I2,': [0] ',$)
      READ(5,50,ERR=30) IDUMMY
   50 FORMAT(I1)
      IF (IDUMMY .GT. MXDUMM-1) GOTO 30
      IF (IDUMMY .LT. 0) GOTO 30
        
        IVERK=IDUMMY+NA-1
        IF (IVERK .LT. 1) THEN
                WRITE(6,55)             
   55   FORMAT( ' At least one dummy-atom has to be defined!!! ' )
                GOTO 30
        ENDIF

      IDIST=0
      WRITE(6,60)
   60 FORMAT(/,' Enter internal coordinates (distances and angles with',
     .       ' dec.point): ',//,
     .       9X,' from to              bond-      dihedral-  ',/,
     .       '          atom atom distance-- angle----- angle----- ',/,
     .       ' Example: 3    5    2.03       11.0       90.        ')
   70 FORMAT('  line# : atom atom distance-- angle----- angle----- ',/,
     .       4X,I3,$,' : ')
   80 FORMAT(BN,2I5,3F11.5)
      DO 100 I=1,IVERK
   90   WRITE(6,70) I
        READ(5,80,ERR=90) NATOM1(I),NATOM2(I),DIST(I),ANGLE(I),DIEDER(I)
  100 CONTINUE
      WRITE(6,110)
  110 FORMAT(/,' List of internal coordinates entered:',/,
     .         '  line# : atom atom distance-- angle----- angle----- ')
  120 FORMAT(4X,I3,' :',2I5,3F11.5)
      DO 130 I=1,IVERK
        WRITE(6,120) I,NATOM1(I),NATOM2(I),DIST(I),ANGLE(I),DIEDER(I)
  130 CONTINUE
      RETURN
      END
