C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE OUTPUT                                               *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Writes inputfile for ICONC(S).                     *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89, by Thomas Hugentobler                    *
C *  Revision...: last revision 24.05.93/mbs (Martin Braendle)       *
C *  Remarks....: Output of FMO specifications added/mbs             *
C *               Output of k specifications added/mbs               *
C *               Output of omit-atom specifications added/mbs       *
C *               Variations with charge iteration now possible/mbs  *
C *               Output of user specified atomic electron configu-  *
C *               ration added./mbs                                  *
C *                                                                  *
C *  Called from: CASE1                                              *
C *                                                                  *
C *  Calls......: CHRIT                                              *
C *                                                                  *
C ********************************************************************

      SUBROUTINE OUTPUT(K,FILNAM)
      IMPLICIT REAL(A-H,O-Z)

      INCLUDE 'inpupara.for'

      CHARACTER*1  BESETZ(MXORB)
      CHARACTER*32 FILNAM
      CHARACTER*80 CHTEMP

      COMMON/AOOCC/NAOOCC,ICONF(MXAOOC,4)
 
      COMMON/ATDEF/IVELEC(MXSYMB),NS(MXSYMB),EXPS(MXSYMB),COULS(MXSYMB),
     .             NP(MXSYMB),EXPP(MXSYMB),COULP(MXSYMB),ND(MXSYMB),
     .             EXPD(MXSYMB),COULD(MXSYMB),C1(MXSYMB),EXPD2(MXSYMB),
     .             C2(MXSYMB)
 
      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM

      COMMON/CONVERT/IVERK,IPARA,IADEF,IADD,IDUMMY,ISUM,IDIST,IVA

      COMMON/FMO/NFMO,FMO(MXATOM),FMOCH(9),PRIFMO(7)
      INTEGER NFMO,FMO,FMOCH
      LOGICAL PRIFMO
 
      COMMON/GENPAR/NVAR(MXVAR),NLINE(MXVAR),NK(MXVAR),CREM(MXVAR),
     .              NKOP(MXVAR)
      CHARACTER*2 NKOP

      COMMON/INTERN/NATOM1(MXTOT),NATOM2(MXTOT),DIST(MXTOT),
     .              ANGLE(MXTOT),DIEDER(MXTOT)

      COMMON/ITERAT/DAMP1,DAMP2,DAMP3,AMPRI,DELTAC,SENSE,MAXCYC,PRTCYC,
     .              NCON,JN,PARTIT
      INTEGER NCON,PRTCYC,MAXCYC
      LOGICAL PARTIT

      COMMON/KOORD/X(MXATOM),Y(MXATOM),Z(MXATOM)

      COMMON/KSET/KATOM(MXSETK,2),SETK(MXSETK),SETD(MXSETK),NKSET
 
      COMMON/NEWDI/CWK,CWKALP

      COMMON/OMITRP/NOMIT,OMIT(MXOMIT)
      INTEGER NOMIT,OMIT

      COMMON/ORBES/BES(MXORB),ODD(MXODD),KL,K2
      INTEGER BES,KL,K2

      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
C
C 15.10.91/mbs
C IADEF: Number of atom definition rows
C IADD : Number of additional lines to be copied
C NLADD: Number of additional lines for charge iteration
C
      NLADD=0
      IADEF=0
      IADD=0
      IF (K .GT. 0) THEN
        DO 10 I=1,K
          IF (IATOM(I) .EQ. ' *') IADEF=IADEF+1
   10   CONTINUE
      ENDIF
      IF (IVA .EQ. 1) GOTO 60
      IF ((K .GT. 0) .AND. (METH .EQ. 2)) THEN
        OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
        NLADD=NLADD+1
        CALL CHRIT(NCON,PARTIT,JN)
        CLOSE (UNIT=1)
C
C Loop for counting lines with parameters for charge-iteration
C
        OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
   20   READ(1,30,END=40) CHTEMP
   30   FORMAT(A80)
        NLADD=NLADD+1
        GOTO 20
   40   CLOSE (UNIT=1)
      ENDIF
C
C Orbital occupation: first run for count of lines
C
      IF (L1) THEN
C
C Calculate number of orbitals K3
C
        K3=0
        DO 50 I=1,NA
          IF (NS(I) .GT. 0) K3=K3+1
          IF (NP(I) .GT. 0) K3=K3+3
          IF (ND(I) .GT. 0) K3=K3+5
   50   CONTINUE
        IORBLI=(K3-1)/78+1
        IADD=IADD+IORBLI 
        IF (K2 .GT. 0) THEN
          IADD=IADD+K2
        ENDIF
      ENDIF
C
C If FMO calculation add 3 or more lines. 22.11.90/mbs
C
      IF (L6) THEN
        IADDLI=(NA-1)/78
        IADD=IADD+IADDLI+3
      ENDIF
C
C If k-parameter specification add NKSET+1 lines. 22.06.91/mbs
C
      IF (L7) THEN
        IADD=IADD+NKSET+1
      ENDIF
C
C If omit-atom specification add the required lines. 24.05.93/mbs
C
      IF (L8) THEN
        IADD=IADD+1
        IF (NOMIT .GT. 10) THEN
          IADD=IADD+(NOMIT-10)/11+1
        ENDIF
      ENDIF
C
C If user specified atomic electron configuration add NAOOCC+1 lines.
C
      IF (L9) IADD=IADD+NAOOCC+1
 
      ISUM=IADEF+NLADD
C
C End of first run for line-counting
C
   60 CONTINUE
C
      OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
      IF (IVA .GT. 1) THEN
C
C Write headerlines for GENIC and CONVC
C
        IF (IVA .EQ. 2) THEN
          WRITE(1,70) IVERK,IPARA,ISUM,IADD
        ENDIF
        WRITE(1,70) IVERK,IDUMMY,ISUM,IDIST
   70 FORMAT(4I4)
      ENDIF
C
C Start of 'conventional' file
C
      WRITE(1,80,ERR=90) MNAM
   80 FORMAT(A80)
   90 CONTINUE
C
C Program parameters
C
      CON=0.
      PEEP=0.
      COULH=0.
      WRITE(1,100) NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,L8,
     .             L9,CWK,PEEP,COULH,(PRT(I),I=1,22)
  100 FORMAT(6I3,9L1,F5.2,2F6.3,22L1)
      WRITE(1,120) CWKALP
C
C Coordinates
C
      IF (IVA .EQ. 1) THEN
C
C Cartesian coordinates
C
        DO 110 I=1,(NH+NA)
          WRITE(1,120) X(I),Y(I),Z(I)
  110   CONTINUE
  120   FORMAT(3F15.6)
      ELSE
C
C Internal coordinates
C
        WRITE(1,130) (NATOM1(J),NATOM2(J),DIST(J),ANGLE(J),DIEDER(J),
     .                J=1,IVERK)
  130   FORMAT(I3,1X,I3,3F10.5)
      ENDIF
C
C Atoms
C
      WRITE(1,140) (IATOM(I),I=1,NA)
  140 FORMAT(40A2)
C
C Atom parameters
C
      IF (K .EQ. 0) GOTO 200
      DO 180 I=1,K
C
C Only write atomic parameters, if there is a ' *' in IATOM
C
        IF (IATOM(I) .EQ. ' *') THEN
          IF (ND(I) .NE. 0) THEN
            WRITE(1,150) SYMBOL(I),IVELEC(I),NS(I),EXPS(I),COULS(I),
     .                   NP(I),EXPP(I),COULP(I),ND(I),EXPD(I),COULD(I),
     .                   C1(I),EXPD2(I),C2(I)
  150       FORMAT(A2,I3,3(I3,F6.4,F6.2),F6.4,F6.3,F6.4)
          ELSE IF (NP(I) .NE. 0) THEN
            WRITE(1,160) SYMBOL(I),IVELEC(I),NS(I),EXPS(I),COULS(I),
     .                   NP(I),EXPP(I),COULP(I)
  160       FORMAT(A2,I3,2(I3,F6.4,F6.2))
          ELSE
            WRITE(1,170) SYMBOL(I),IVELEC(I),NS(I),EXPS(I),COULS(I)
  170       FORMAT(A2,I3,I3,F6.4,F6.2)
          ENDIF
        ENDIF
  180 CONTINUE
C
C Charge iteration parameters
C
      IF (METH .EQ. 2) THEN
        WRITE(1,190) DAMP1,DAMP2,DAMP3,AMPRI,DELTAC,SENSE,MAXCYC,PRTCYC,
     .               NCON,PARTIT
  190   FORMAT(6F10.5,3I5,4X,L1)
C
C Atomic parameters for charge iteration
C
        CALL CHRIT(NCON,PARTIT,JN)
      ENDIF
  200 CONTINUE
C
C Write FMO specifications. 22.11.90/mbs
C
      IF (L6) THEN
        WRITE(1,210) (FMO(I),I=1,NA)
  210   FORMAT(78I1)
        WRITE(1,220) (FMOCH(I),I=1,9)
  220   FORMAT(9I3)
        WRITE(1,230) (PRIFMO(I),I=1,7)
  230   FORMAT(7L1)
      ENDIF
C
C Write (kappa,delta)-parameter specifications. 22.06.91/mbs
C
      IF (L7) THEN
        WRITE(1,240) NKSET
  240   FORMAT(I3)
        DO 260 I=1,NKSET
          WRITE(1,250) KATOM(I,1),KATOM(I,2),SETK(I),SETD(I)
  250     FORMAT(2I4,2F10.5)
  260   CONTINUE
      ENDIF
C
C Write omit-atom specifications. 22.06.91/mbs
C
      IF (L8) THEN
        WRITE(1,270) NOMIT,(OMIT(I),I=1,NOMIT)
  270   FORMAT(11I4)
      ENDIF
C
C Write user specified atomic electron configurations. 01.06.92/mbs
C
      IF (L9) THEN
        WRITE(1,280) NAOOCC
  280   FORMAT(I2)
        IF (NAOOCC .GT. 0) THEN
          DO 300 I=1,NAOOCC
            WRITE(1,290) (ICONF(I,J),J=1,4)
  290       FORMAT(4I3)
  300     CONTINUE
        ENDIF
      ENDIF
C
C Generate string with orbital occupation
C
      IF (L1) THEN
        DO 320 I=1,K3
          BESETZ(I)='0'
          IF (BES(I) .GT. 0) THEN
            BESETZ(I)=CHAR(BES(I)+48)
          ENDIF
  320   CONTINUE
        WRITE(1,330) (BESETZ(I),I=1,K3)
  330   FORMAT(78A1)
        IF (K2 .GT. 0) THEN
          DO 350 I=1,K2
            WRITE(1,340) ODD(I)
  340       FORMAT(F10.8)
  350     CONTINUE
        ENDIF
      ENDIF
C
C Write Parameter-Lines for GENIC
C
      IF (IVA .GT. 1) THEN
        WRITE(1,360) (NVAR(J),NKOP(J),NLINE(J),NK(J),CREM(J),J=1,IPARA)
  360   FORMAT(I3,A2,2I3,F10.6)
      ENDIF
C
C Write the MOBY filename in *.inp if MOBY-OUTPUT is wished 
C (Flag PRT(22)) 13.05.92/rr
C
      IF (PRT(22) .AND. ((IVA .EQ. 1) .OR. (IVA .EQ. 2))) THEN
        WRITE(1,' (A8) ') FILNAM(1:(INDEX(FILNAM,'.')-1))
      ENDIF

      CLOSE (UNIT=1)
      RETURN
      END
