C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE VARIN                                                *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads variation parameters for GENINSC program     *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM extended./mbs                   *
C *                                                                  *
C *  Called from: CASE1                                              *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE VARIN
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      CHARACTER*5 KOP
 
      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM
 
      COMMON/CONVERT/IVERK,IPARA,IADEF,IADD,IDUMMY,ISUM,IDIST,IVA
 
      COMMON/GENPAR/NVAR(MXVAR),NLINE(MXVAR),NK(MXVAR),CREM(MXVAR),
     .              NKOP(MXVAR)
      CHARACTER*2 NKOP
 
      COMMON/INTERN/NATOM1(MXTOT),NATOM2(MXTOT),DIST(MXTOT),
     .              ANGLE(MXTOT),DIEDER(MXTOT)
 
      WRITE(6,10)
   10 FORMAT(/,' Parameters for variation; each line describes ',
     .       'variations of an int. coordinate:',/,
     . '  - # of variations                             (#-v.)     ',/,
     . '  - Coupling with last variation ? (space or Y) (cpl.)     ',/,
     . '  - Line-# of vector                            (line#)    ',/,
     . '  - Var. of 1=dist. 2=bond-ang. 3=dihedral-ang. ([1-3])    ',/,
     . '  - Increment                                   (increment)',/,
     . ' Example: #-v. cpl. line# [1-3] increment ',/,
     . '      1 : 10        5     1     0.05      ',/,
     . '      2 : 5     y   6     3     10.0      ',/,
     . ' Exit with an empty line!        ')
   20 FORMAT(9X,' #-v. cpl. line# [1-3] increment ',/,$,4X,I3,$,' : ')
   30 FORMAT(BN,I5,A5,I6,I6,F10.5)
      I=1
   40 WRITE(6,20) I
      READ(5,30,ERR=40) NVAR(I),KOP,NLINE(I),NK(I),CREM(I)
      IF (NVAR(I) .GT. 0) THEN
        IF ((INDEX('0',KOP) .GT. 0) .OR. (INDEX('N',KOP) .GT. 0) .OR.
     .  (INDEX('n',KOP) .GT. 0) .OR. (INDEX('     ',KOP) .GT. 0)) THEN
          NKOP(I)='  '
        ELSE
          NKOP(I)=' *'
        ENDIF
        IF (I .EQ. 1) NKOP(I)='  '
        I=I+1
        IPARA=I
        IF (IPARA .LE. MXVAR) GOTO 40
      ELSE
        IPARA=I-1
      ENDIF
      RETURN
      END
